<template>
  <div>
    <Modal v-model="showModal" width="1100" class="modal-footer-none zIndex-1100">
      <p slot="header">
        选择所要归类的耗材
      </p>
      <div>
        <Row>
          <!--查询-->
          <Col span="24" />
          <Form inline onsubmit="return false" :label-width="70">
            <label class="label-sign" />
            <Form-item label="耗材编号:">
              <Input
                v-model="formObj.num"
                placeholder="请输入耗材编号"
                style="width: 200px"
                clearable
                @on-enter="_search"
              />
            </Form-item>
            <Form-item label="耗材名称:">
              <Input
                v-model="formObj.name"
                placeholder="请输入耗材名称"
                style="width: 200px"
                clearable
                @on-enter="_search"
              />
            </Form-item>

            <Form-item label="耗材类别:">
              <Input
                v-model="formObj.category"
                placeholder="请输入耗材类别"
                style="width: 200px"
                clearable
                @on-enter="_search"
              />
            </Form-item>

            <Form-item label="规格:">
              <Input
                v-model="formObj.spec"
                placeholder="请输入规格"
                style="width: 200px"
                clearable
                @on-enter="_search"
              />
            </Form-item>
            <Form-item class="search-btn">
              <Button type="primary" @click="_search">
                搜索
              </Button>
            </Form-item>
          </Form>
          </Col>
          <!-- 表格 -->
          <Col span="24" />
          <element-table
            ref="pageTable"
            :table-height="tableHeight"
            :get-page="getPage"
            show-check-box
            @on-result-change="_tableResultChange"
          >
            <el-table-column
              v-for="item in pageColumns"
              :key="item.key"
              show-overflow-tooltip
              :prop="item.key"
              :label="item.title"
              :min-width="item.width"
              :fixed="item.fixed?item.fixed:undefined"
            >
              <template slot-scope="scope">
                <span v-if="item.key==='type'">
                  {{ scope.row[item.key] === 0 ? '流转' : scope.row[item.key] === 1 ? '退回': scope.row[item.key] === 2 ?'更新' :
                    scope.row[item.key] === 3 ? '转发':'文件' }}
                </span>
                <span v-else-if="item.key==='ctime'">{{ scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd HH:MM:ss'):'' }}</span>
                <span v-else>{{ scope.row[item.key] }}</span>
              </template>
            </el-table-column>
          </element-table>
          </Col>
        </Row>
      </div>
      <div slot="footer">
        <modal-footer ref="footerModal" :footer="footerList" @on-result-change="_footerResult" />
      </div>
    </Modal>
  </div>
</template>
<script>
/**
 * 操作日志-委托
 */
import { consumeClassify, consumeLedger } from '../../../api'
export default {
  data() {
    return {
      showModal: false,
      getPage: {},
      selectIds: [],
      footerList: [
        { name: '取消', type: '' },
        { name: '确定', type: 'primary' }
      ],
      pageColumns: [
        { title: '耗材编号', width: 100, key: 'num' },
        { title: '耗材名称', key: 'name', width: 140, detail: true },
        { title: '耗材类别', width: 140, key: 'category' },
        { title: '库存量', width: 100, key: 'stock' },
        { title: '计量单位', width: 100, key: 'unit' },
        { title: '仓库位置', width: 200, key: 'storehouse' },
        { title: '等级（纯度）', width: 150, key: 'quality' },
        { title: '规格', width: 100, key: 'spec' },
        { title: '制造厂商', width: 200, key: 'manufacturer' },
        { title: '密度', width: 100, key: 'thickness' },
        { title: '精确度等级', width: 100, key: 'unsure' },
        { title: '标准值', width: 100, key: 'standard' },
        { title: '转化单位', width: 120, key: 'exunit' },
        { title: '备注', width: 120, key: 'remark' }
      ],
      formObj: {
        num: '',
        category: '',
        spec: '',
        name: '',
        classifyId: ''
      },
      classifyId: '',
      submitData: {
        // 要提交至归类的数据
        classifyId: '',
        chemicalIds: []
      }
    }
  },
  computed: {
    tableHeight: function() {
      return this.$tableHeight('tableModal') - 120
    }
  },
  methods: {
    _open(classifyId) {
      this.showModal = true
      this.formObj.classifyId = classifyId
      this.submitData.classifyId = classifyId
      this.classifyId = classifyId
      this._page()
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      const database = this.$serializeForm(this.formObj)
      console.log(database)
      const result = await consumeLedger.pageExcludeClassify(
        this.$serializeForm(this.formObj)
      )
      if (result) {
        this.getPage = result
        this.$refs.pageTable._initTable()
      }
    },
    _searchParams(formId) {
      return this.$refs.pageTable._searchParams(formId)
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'page':
          this._page()
          break
        case 'iconClick':
          this._iconClick(data.name, data.rowData)
          break
        case 'selectIds':
          this.selectIds = data
          break
      }
    },

    _hideLoading() {
      this.$refs.footerModal._hideLoading()
    },
    _footerResult(name) {
      switch (name) {
        case '取消':
          this._cancel()
          break
        case '确定':
          this._ok()
          break
      }
    },
    _cancel() {
      this.showModal = false
      this.classifyId = ''
      this.submitData = []
      this.formObj = []
      this._hideLoading()
    },
    _ok() {
      const ids = this.selectIds
      this.submitData.chemicalIds = ids
      if (ids === '') {
        this.$Message.warning('请选择要进行归类的产品！')
      } else {
        this._save(this.submitData)
      }
    },
    _save: async function(data) {
      const result = await consumeClassify.saveClassifyConsume(data)
      if (result) {
        this.$Message.success('归类成功！')
        this.showModal = false
        this.$emit('on-result-change')
      }
      this._hideLoading()
    },
    _search() {
      this.$refs.pageTable._pageChange(1)
    }
  }
}
</script>
